<template>
  <div class="max-big-box">
    <div class="big-max-box" v-show="pageType==0">
      <div class="top-box">
        <div class="input-box">
          <input class="search-input" type="text" v-model="inputData" placeholder="请输入敏感词汇关键字进行查询">
          <div class="time-box">
            <p>创建时间：</p>
            <p class="cursor_pointer" @click="openTimeBox('1')">{{playTime}}</p>
            <p>-</p>
            <p class="cursor_pointer" @click="openTimeBox('2')">{{endTime}}</p>
          </div>
          <div class="button-box cursor_pointer" @click="clickQuery">
            <img src="~@/assets/images/icon_27.png">
            <p class="cursor_pointer">查询</p>
          </div>
        </div>
        <p class="add-button cursor_pointer" @click="clickPageType" v-if="userPermsData.indexOf('business:sensitiveWords:add')!=-1">新增</p>
        <p class="del-button cursor_pointer" @click="allDel" v-if="userPermsData.indexOf('business:sensitiveWords:remove')!=-1">批量删除</p>
        <p class="text-p">已选择{{tableNum}}条</p>
      </div>
      <!--表格-->
      <div class="table-box">
        <el-table
          ref="multipleTable"
          :row-key="getRowKey"
          :data="tableData"
          tooltip-effect="dark"
          style="width: 100%"
          @select-all="handleSelectionChange"
          @select="handleSelectionChange">
          <el-table-column
            :reserve-selection="true"
            type="selection"
            width="52">
          </el-table-column>
          <el-table-column
            type="index"
            :index="indexMethod"
            label="序号"
            width="54">
          </el-table-column>
          <el-table-column
            prop="sensitiveWords"
            label="敏感词汇"
            width="305">
          </el-table-column>
          <el-table-column
            prop="remark"
            label="备注"
            width="268">
          </el-table-column>
          <el-table-column
            prop="userName"
            label="创建人姓名"
            width="425">
          </el-table-column>
          <el-table-column
            prop="createTime"
            label="创建时间"
            width="233">
          </el-table-column>
          <el-table-column
            label="操作"
            width="373">
            <template slot-scope="scope">
              <div class="table-min-button">
                <div class="cursor_pointer" @click="handleInfo(scope.$index, scope.row)">
                  <img src="~@/assets/images/icon_36.png">
                  <p>详情</p>
                </div>
                <div class="cursor_pointer"
                     v-if="userPermsData.indexOf('business:sensitiveWords:edit')!=-1"
                     @click="handleEdit(scope.$index, scope.row)">
                  <img src="~@/assets/images/icon_37.png">
                  <p>编辑</p>
                </div>
                <div class="cursor_pointer"
                     v-if="userPermsData.indexOf('business:sensitiveWords:remove')!=-1"
                     @click="handleDelete(scope.$index, scope.row)">
                  <img src="~@/assets/images/icon_38.png">
                  <p>删除</p>
                </div>
              </div>
            </template>
          </el-table-column>
        </el-table>
      </div>
      <el-pagination
        background
        @current-change="handleCurrentChange"
        layout="prev, pager, next"
        :current-page="currentPage"
        :page-size="pagesize"
        :total="total">
      </el-pagination>
      <!--时间日历-->
      <div class="time-max-big-box" v-if="timeType!=0">
        <div class="time-big-box">
          <el-calendar class="time-min-box" v-model="timeValue">
          </el-calendar>
          <div class="button-box">
            <p class="cursor_pointer" @click="openTimeBox('0')">返回</p>
            <p class="cursor_pointer" @click="clearTimeData">清除</p>
            <p class="cursor_pointer" @click="setTimeData">确定</p>
          </div>
        </div>
      </div>
    </div>
    <details-page :dataInfo="dataInfo" v-if="pageType==1"></details-page>
    <new-modify
      v-if="!newModifyPageType"
      :newModifyData="newModifyData"
      @newModifyLeftClick="newModifyLeftClick"
      @newModifyRightClick="newModifyRightClick"
    ></new-modify>
    <interactive-window
      v-if="windowType"
      :windowData="windowData"
      @windowLeftClick="windowLeftClick"
      @windowRightClick="windowRightClick"
    ></interactive-window>
  </div>
</template>

<script>
  import { sensitiveWordsList,sensitiveWordsDel,sensitiveWordsAdd,sensitiveWordsEditor } from '@/api/userApi'
  export default {
    name: "sensitiveWordManagement",//敏感词汇管理
    components:{
      detailsPage: resolve => {require(['@/components/detailsPage'], resolve)},//详情组件
      newModify: resolve => {require(['@/components/newModify'], resolve)},//新建-修改组件
      interactiveWindow: resolve => {require(['@/components/interactiveWindow'], resolve)},//提示弹窗
    },
    data () {
      return {
        userPermsData:localStorage.getItem('userPerms'),
        //搜索数据
        inputData:"",
        //日历时间
        timeValue: new Date(),
        timeType:0,
        //搜索时间
        playTime:"请选择时间",
        endTime:"请选择时间",
        //表格限制
        pagesize: 8,
        currentPage:1,
        //列表总数
        total:0,
        /*数据*/
        tableData:[],
        //勾选
        multipleSelection:[],
        tableNum:0,
        // 详情页状态
        pageType:0,
        //给组件传参数据
        dataInfo:[],
        // 弹窗状态
        windowType:false,
        //弹窗组件数据
        windowData:{},
        // 新增-修改页面状态
        newModifyPageType:true,
        //新增-修改页面数据
        newModifyData:{}
      }
    },

    created(){

    },
    mounted() {
      this.getListData();
    },
    methods: {
      //点击查询
      clickQuery(){
        this.currentPage = 1;
        this.getListData();
      },
      // 单独删除
      async clickDel(id){
        let ids = [];
        ids.push(id)
        const { data } = await sensitiveWordsDel(ids);
        if(data.code==200){
          this.windowData = {
            type:"2",
            title:"提示",
            text:"操作成功",
          };
          this.windowType = !this.windowType;
          this.$refs.multipleTable.clearSelection();
          this.getListData();
        }
      },
      //批量删除
      async clickAllDel () {
        let self = this;
        let ids = [];
        for(let i=0;i<self.multipleSelection.length;i++){
          ids.push(self.multipleSelection[i].id)
        }
        const { data } = await sensitiveWordsDel(ids);
        if(data.code==200){
          this.windowData = {
            type:"2",
            title:"提示",
            text:"操作成功",
          };
          this.windowType = !this.windowType;
          this.$refs.multipleTable.clearSelection();
          this.getListData();
        }
      },
      //数据列表
      async getListData () {
        let self = this;
        let obj={
          sensitiveWords:self.inputData,
          pageSize:self.pagesize,
          pageNum:self.currentPage,
          "params[beginTime]":self.playTime=="请选择时间"?"":self.playTime,
          "params[endTime]":self.endTime=="请选择时间"?"":self.endTime,
        };
        const { data } = await sensitiveWordsList(obj);
        if(data.code==200){
          this.tableData = data.rows;
          this.total = data.total;
          this.tableNum = 0;
          this.$forceUpdate();
        }
      },
      //新建组件状态切换
      clickPageType(){
        let newData = {
          title:"新增",
          type:"1",
          list:[
            {
              name:"敏感词",
              value:""
            },
            {
              name:"备注",
              value:"",
              textArea:true
            },
          ]
        };
        this.newModifyData = {...newData};
        this.pageType=2;
        this.newModifyPageType = !this.newModifyPageType;
      },
      // 批量删除
      allDel(){
        if(this.multipleSelection[0]){
          this.windowData = {
            type:"1",
            title:"提示",
            text:"确定要批量删除这些信息吗?",
            leftButton:"取消",
            rightButton:"确定",
            cType:"1",
          };
          this.windowType = !this.windowType;
        }else{
          this.windowData = {
            type:"3",
            title:"提示",
            text:"您没有勾选任何数据!",
            leftButton:"取消",
            rightButton:"确定",
          };
          this.windowType = !this.windowType;
        }
      },
      //新增-修改组件内左侧按钮事件
      newModifyLeftClick(){
        this.pageType=0;
        this.newModifyPageType = !this.newModifyPageType;
      },
      //新增-修改组件内左侧按钮事件
      newModifyRightClick(data){
        if(!data.list[0].value){
          this.windowData = {
            type:"3",
            title:"提示",
            text:"请输入敏感词",
          };
          this.windowType = !this.windowType;
          return
        }else if(!data.list[1].value){
          this.windowData = {
            type:"3",
            title:"提示",
            text:"请输入备注",
          };
          this.windowType = !this.windowType;
          return
        }
        if(data.type=="1"){
          this.sensitiveWordsAdd(data);
        }else if(data.type=="2"){
          this.sensitiveWordsEditor(data);
        }
      },
      //新增
      async sensitiveWordsAdd (item) {
        let self = this;
        let obj={
          sensitiveWords:item.list[0].value,
          remark:item.list[1].value,
        };
        const { data } = await sensitiveWordsAdd(obj);
        if(data.code==200){
          this.newModifyPageType = !this.newModifyPageType;
          this.pageType = 0;
          this.windowData = {
            type:"3",
            title:"提示",
            text:"新增成功",
          };
          this.windowType = !this.windowType;
          this.getListData();
        }
      },
      //编辑
      async sensitiveWordsEditor (item) {
        let self = this;
        let obj={
          id:item.id,
          sensitiveWords:item.list[0].value,
          remark:item.list[1].value,
        };
        const { data } = await sensitiveWordsEditor(obj);
        if(data.code==200){
          this.newModifyPageType = !this.newModifyPageType;
          this.pageType = 0;
          this.windowData = {
            type:"3",
            title:"提示",
            text:"编辑成功",
          };
          this.windowType = !this.windowType;
          this.getListData();
        }
      },
      //表格绑定ID
      getRowKey (row) {
        return row.id
      },
      indexMethod(index) {
        return (this.currentPage-1)*this.pagesize+index+1;
      },
      //时间选择事件
      openTimeBox(type){
        this.timeType=type
      },
      setTimeData(){
        let year = this.timeValue.getFullYear();
        let month = this.timeValue.getMonth()+1;
        let day = this.timeValue.getDate();
        if(this.timeType==1){
          this.playTime = year+'-'+month+'-'+day;
        }else if(this.timeType==2){
          this.endTime = year+'-'+month+'-'+day;
        }
        this.timeType = 0;
      },
      clearTimeData(){
        if(this.timeType==1){
          this.playTime = "请选择时间";
        }else if(this.timeType==2){
          this.endTime = "请选择时间";
        }
        this.timeType = 0;
      },
      //翻页
      handleCurrentChange(val) {
        console.log(`当前页: `,val);
        this.currentPage = val;
        this.getListData();
      },
      //查看
      handleInfo(index, row){
        console.log("详情",index, row);
        this.dataInfo =[
          {
            name:"敏感词汇",
            value:row.sensitiveWords,
          },
          {
            name:"备注",
            value:row.remark,
          },
          {
            name:"创建人姓名",
            value:row.userName,
          },
          {
            name:"创建时间",
            value:row.createTime,
          },
        ];
        this.pageType = 1;
      },
      // 编辑
      handleEdit(index, row) {
        let newData = {
          title:"编辑",
          type:"2",
          id:row.id,
          list:[
            {
              name:"敏感词",
              value:row.sensitiveWords,
            },
            {
              name:"备注",
              value:row.remark,
              textArea:true
            },
          ]
        };
        this.newModifyData = {...newData};
        this.pageType = 2;
        this.newModifyPageType = !this.newModifyPageType;
      },
      //删除
      handleDelete(index, row) {
        this.windowData = {
          type:"1",
          title:"提示",
          text:"确定要删除这条信息吗?",
          leftButton:"取消",
          rightButton:"确定",
          cType:"2",
          newId:row.id
        };
        this.windowType = !this.windowType;
      },
      //勾选
      handleSelectionChange(val) {
        this.multipleSelection = val;
        this.tableNum = this.multipleSelection.length
      },
      //供子组件调用方法
      outPage(){
        this.pageType = 0;
      },
      //弹窗组件左侧按钮方法-对应取消方法
      windowLeftClick(){
        this.windowType = !this.windowType;
      },
      //弹窗组件右侧按钮方法
      windowRightClick(data){
        this.windowType = false;
        if(data.cType==1){
          this.clickAllDel();
        }else if(data.cType==2){
          this.clickDel(data.newId);
        }
      },
    }
  }
</script>

<style scoped lang="stylus">
.max-big-box
  display flex
  flex-direction column
  flex:1;
  .big-max-box
    display flex
    flex-direction column
    flex:1;
    //搜索与操作按钮
    .top-box
      height:30px;
      display flex
      .input-box
        width:1370px;
        display flex
        margin-left:105px;
        .search-input
          height:28px;
          width:290px;
          border:1px solid $theme;
          padding-left:10px;
        .time-box
          width:349px;
          display flex
          margin-left:20px;
          p
            color:$color_ff;
          p:nth-child(1)
            width:82px;
            line-height:30px;
            font-size:$font_14;
          p:nth-child(2)
            width:120px;
            height:30px;
            background url("~@/assets/images/button_08.png")
            background-size 100% 100%
            font-size:$font_12;
            line-height:30px;
          p:nth-child(3)
            width:27px;
            line-height:30px;
          p:nth-child(4)
            width:120px;
            height:30px;
            background url("~@/assets/images/button_08.png")
            background-size 100% 100%
            line-height:30px;
            font-size:$font_12;
        .button-box
          margin-left:32px;
          display flex
          height:30px;
          width:80px;
          background:url("~@/assets/images/button_03.png");
          background-size:100% 100%;
          img
            display block
            height:20px;
            width:20px;
            margin:5px 6px 0 13px;
          p
            line-height:30px;
            font-size:$font_12;
            color:$color_ff;
      .add-button
        width:110px;
        height:30px;
        background:url("~@/assets/images/button_06_1.png");
        background-size:100% 100%;
        line-height:30px
        color:$color_ff;
        font-size:$font_12;
        padding-left:44px;
        text-align left
      .del-button
        margin-left:30px;
        width:110px;
        height:30px;
        background:url("~@/assets/images/button_05_1.png");
        background-size:100% 100%;
        line-height:30px
        color:$color_ff;
        font-size:$font_12;
        padding-left:41px;
        text-align left
      .text-p
        width:90px;
        color:$color_ff;
        line-height:30px
        font-size:$font_12;
    //表格
    .table-box
      width:1710px !important;
      margin:20px 105px;
      text-align center !important
      .table-min-button
        width:210px;
        margin:0 auto;
        display flex
        div:nth-child(1)
          height:20px;
          width:60px;
          font-size:$font_14;
          color:$theme;
          display flex
          margin-right:11px;
          img
            display block
            height:20px;
            width:20px;
            margin-right:4px;
        div:nth-child(2)
          height:20px;
          width:60px;
          font-size:$font_14;
          color:$theme;
          display flex
          margin-right:11px;
          img
            display block
            height:20px;
            width:20px;
            margin-right:4px;
        div:nth-child(3)
          height:20px;
          width:60px;
          font-size:$font_14;
          color:$theme3;
          display flex
          img
            display block
            height:20px;
            width:20px;
            margin-right:4px;
    //时间日历
    .time-max-big-box
      z-index 6
      height:100%;
      width:100%;
      position: absolute
      top:0;
      left:0;
      background:rgba(0,0,0,0.3);
      .time-big-box
        z-index 6
        height:750px;
        width:660px;
        position: absolute
        top:50%;
        left:50%;
        transform :translate3d(-50%,-50%,0)
        margin:auto;
        background-color $color_ff
        border-radius:8px;
        border:4px solid $theme;
        .button-box
          display flex
          color:$color_ff;
          width:390px;
          margin:20px auto;
          p:nth-child(1)
            height:30px;
            line-height:30px;
            width:120px;
            background:url("~@/assets/images/button_10.png");
            background-size 100% 100%
          p:nth-child(2)
            margin-left:20px;
            height:30px;
            line-height:30px;
            width:120px;
            background:url("~@/assets/images/button_05.png");
            background-size 100% 100%
          p:nth-child(3)
            margin-left:20px;
            height:30px;
            line-height:30px;
            width:120px;
            background:url("~@/assets/images/button_02.png");
            background-size 100% 100%
  //修改日期选择样式
  /*
  .el-calendar
    background $color_ff
  */
  .el-calendar
    background rgba(255,255,255,0)
  //修改table表格样式
  .el-table
    background rgba(6,177,240,0.2)
  .el-table /deep/ tr
  .el-table /deep/ th
    background rgba(6,177,240,0)
  .el-table::before
    height:0;
  .el-table /deep/ .cell
    max-height:46px;
    display: -webkit-box;
    -webkit-box-orient: vertical;
    -webkit-line-clamp: 2;
    overflow: hidden;
  .el-table /deep/ td
  .el-table /deep/ th.is-leaf
    border-bottom:0!important;
  .el-table /deep/ .el-checkbox__inner
    //background rgba(6,177,240,0.2)
    border 1px solid #216f93 !important
  .el-table /deep/ thead
    color:$color_ff;
  .el-table
    color:$color_a1
  .el-table /deep/ th
    text-align-last: center;
  .el-table /deep/ td
    text-align-last: center;
  .el-table /deep/ tbody tr:hover > td
    background rgba(6,177,240,0.2)
    color:$theme;
  .el-table /deep/ .el-checkbox
    width:14px;
    margin:0 auto;
    display block
  //修改动作条样式
  .el-pagination.is-background /deep/ .btn-next
  .el-pagination.is-background /deep/ .btn-prev
  .el-pagination.is-background /deep/ .el-pager li
    background:url("~@/assets/images/button_13.png");
    color:$color_ff;
  .el-pagination.is-background /deep/ .el-pager li:not(.disabled).active
    background:url("~@/assets/images/button_14.png");
    color:$color_ff;
  .colorA
    color :$theme;
  ::-webkit-input-placeholder
    color: $border_1;
  ::-moz-placeholder
    color: $border_1;
  ::-ms-input-placeholder
    color: $border_1;
</style>
